package com.lantone.common.service.impl;

import com.lantone.common.service.SpringContextService;
import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;

/**
 * @Description: 获取Spring容器中的Bean
 * @author: rengb
 * @time: 2022/4/12 18:24
 */
public class SpringContextServiceImpl implements SpringContextService {

    private static ApplicationContext applicationContext = null;

    //获取applicationContext
    public static ApplicationContext getApplicationContext() {
        return applicationContext;
    }

    //通过name获取 Bean
    public static <T> T getBean(String name) {
        return (T) applicationContext.getBean(name);
    }

    //通过class获取Bean
    public static <T> T getBean(Class<T> clazz) {
        return applicationContext.getBean(clazz);
    }

    //通过name,以及Clazz返回指定的Bean
    public static <T> T getBean(String name, Class<T> clazz) {
        return applicationContext.getBean(name, clazz);
    }

    @Override
    public void setApplicationContext(ApplicationContext applicationContext) throws BeansException {
        if (this.applicationContext == null) {
            this.applicationContext = applicationContext;
        }
    }

}